/****************************************************************************
Program    : Message
Version    : 1.00.A
Programmer : Binny V Abraham
E-Mail     : binnyva@rediffmail.com
Website    : http://www.geocities.com/binnyva
C++ Special: http://www.geocities.com/binnyva/code/cpp/

Use
---
Displays a message box in DOS. The cotents can be specifed the user. It 
can aslo be a confirmation box with 'Yes' and 'No' Buttons.

Special
-------
This is a part of the Batch Toolkit by Binny's softwares. To find out more,
go to http://www.geocities.com/binnyva. Programs in Batch Toolkit -
Becho, Getline, Message, Select, Tnd. Made for use in Batch files.

License
-------
You can use this program, modify it, distribute it, make money from it or
any thing by it. But please give credit where credit is due. Mention my name
or my site in the credits.

Disclamer
---------
If any thing happens to your computer by using my program, it is NOT my porblem. 
It will be your own fault.

If you want more info, contact me at binnyva@rediffmail.com.
****************************************************************************/
#include <string.h>
#include <iostream.h>
#include <conio.h>
#include <process.h>

//Global Variable
char version[]="1.00.A";
//Default settings
int hide_shadow=0;
int delimiter=-1; //The chars that appear at the ends of buttons
//Colours
int border_color= WHITE;
int background  = LIGHTGRAY;
int text_color  = WHITE;
int button_background = BLACK;
int button_text_color = WHITE;
int disabled_background = BLACK;
int disabled_text_color = DARKGRAY;
int shadow_color = DARKGRAY;

//Every thing from here to main is copied from 'Gui.h'. Some are changed.
struct dimensions
 {
 int x;
 int y;
 int width;
 int height;
 char buffer[4096]; //When a box is draw, the text behind is stored here.
 };

/*****************************Draws a box*****************************/
void box(int x,int y,int width,int height)
 {
 int i,j;
 //Clear the space.
 for(j=y;j<y+height;j++)
 for(i=x;i<x+width;i++)
  {
  gotoxy(i,j);cputs(" ");
  }
 //Draw the box
 for(i=x+1;i<x+width;i++)
  {
  gotoxy(i,y);cputs("");
  gotoxy(i,y+height);cputs("");
  }
 for(i=y+1;i<y+height;i++)
  {
  gotoxy(x,i);cputs("");
  gotoxy(x+width,i);cputs("");
  }
 //The Conners
 gotoxy(x,y);cputs("");
 gotoxy(x+width,y);cputs("");
 gotoxy(x,y+height);cputs("");
 gotoxy(x+width,y+height);cputs("");
 }

/**********************************************************************
Function: void button(int PosX,int PosY,char button_label[10],int Selection)
Use     : Makes a button with the User defined text. Uses Drop Shadow
	  effect for the button. User can also specify wether it is
	  selected or not.
Syntax  : button(25,12,"Hello World",1);
**********************************************************************/
void button(int PosX,int PosY,char button_label[10],int sel)
 {
 char button[15]="";
 char delim1[3]="",delim2[3]="";
 //Delimiters - the charectors at the ends of buttons
 if(delimiter==0)
  {
  strcpy(delim1," ");
  strcpy(delim2," ");
  }
 else if(delimiter==1)
  {
  strcpy(delim1,"<");
  strcpy(delim2,">");
  }
 else if(delimiter==2)
  {
  strcpy(delim1,"-");
  strcpy(delim2,"-");
  }
 else if(delimiter==3)
  {
  strcpy(delim1,"[");
  strcpy(delim2,"]");
  }
 else if(delimiter==4)
  {
  strcpy(delim1,".:");
  strcpy(delim2,":.");
  }
//gotoxy(2,25);cout<<"Delim : "<<delimiter<<" | Left : "<<delim1<<" | Right : "<<delim2;
 //Bring the text of button together
 strcat(button,delim1);strcat(button,button_label);strcat(button,delim2);

 int l=strlen(button);

 //Selection status
 if(sel==1) //Selected
  {
  textcolor(button_text_color);
  textbackground(button_background);
  }
 else //Not Selected
  {
  textcolor(disabled_text_color);
  textbackground(disabled_background);
  }
 //If 'hide_shadow' is set, its value will be 1 and button will be
 //	1 line down. Else value will be 0 and it will be in correct
 //	position
 gotoxy(PosX,PosY+hide_shadow);cputs(button);//Print the button

 if(!hide_shadow)
  {
  textbackground(background);textcolor(shadow_color);
  //Drop Shadow Effect
  cputs("");
  for(int i=1;i<=l;i++)
   {
   gotoxy(PosX+i,PosY+1);
   cputs("");
   }
  }
 }
/**********************************************************************
Function: dimensions messageBox(char text[200],int type)
Use     : Makes the basic message box and puts the text in it. Buttons
          are not drawn. This function is needed for alert(),confirm()
          and prompt(). The type specifies what kind of box it is.
	  The value of type is
	  '0' - alert box
          '1' - confirm box.
          '3' - prompt box
Syntax  : messageBox("Hello Everyone",0);
**********************************************************************/
dimensions messageBox(char text[200],int type)
 {
 int l=strlen(text);
 char txt[5][70];
 int largest_txt=0;
 int lines=0;
 int i,j,k;
 //The positions of all '\n' will be stored here.
 int new_line_pos[5],count_new_line_pos=1;
 new_line_pos[0]=0;

 for(i=0;i<l;i++)
  {
  //For ever '\n' and end of line
  if((text[i]=='\\'&&text[i+1]=='n')||i==l-1)
   {
   new_line_pos[count_new_line_pos] = i;
   count_new_line_pos++;

   //Copies all info from last '\n' to the next
   k=0;
   for(j=new_line_pos[count_new_line_pos-2];j<new_line_pos[count_new_line_pos-1];j++)
    {
    //So that the '\<whatever>' wont be printed.
    if(text[j]=='\\'&&text[j+1]=='n') j++;
    else if(text[j]=='\\'&&text[j+1]=='a') j++;
    else
     {
     txt[lines][k]=text[j];
     k++;
     }
    }
   if(k>strlen(txt[largest_txt])) largest_txt=lines; //Find the largest string
   txt[lines][k]='\0';//Give a null terminator at the end of the string.

   lines++;
   }
  else if(text[i]=='\\'&&text[i+1]=='a') //Audiable Bell
   { cout<<"\a"; }
  }

 int max_len=strlen(txt[largest_txt]);
 int x=0,y=0;
 int width = max_len+4;
 int height = lines+3;
 if(type==3) //If it is a prompt box
  {
  if(width<21) width=21;
  if(height<5) height=5;
  }
 else
  {
  if(type==1) //If it is a confirm box
   {
   if(width<21) width=21;
   }
  else //If it is an alert box
   {
   if(width<11) width=11;
   }
  if(height<4) height=4;
  }

 //This will centralize the message box.
 x=(80-width)/2;
 y=(25-height)/2;

 //This will copy the stuff that was there before the window came
 char buffer[4096]; //When a box is draw, the text behind it is stored here.
 gettext(x,y,x+width,y+height, buffer);

 //Draw the box
 textbackground(background);textcolor(border_color);
 box(x,y,width,height);

 textcolor(text_color);
 //Put the message line by line inside the box
 for(i=0;i<lines;i++)
  {
  gotoxy(x+2,y+1+i);
  cputs(txt[i]);
  }

 //Store all nessary things in a sturcture called dimensions.
 dimensions dim;
 dim.x=x;
 dim.y=y;
 dim.width=width;
 dim.height=height;
 strcpy(dim.buffer,buffer);

 return dim;
 }

/**********************************************************************
Function: alert(char text[200])
Use     : Makes a alert type message box with a user defined text.
          Exits only if 'Enter', 'Space Bar' or 'Esc' is pressed.
Syntax  : alert("Hello World\nCome to\nhttp://www.geocities.com/binnyva ");
**********************************************************************/
void alert(char text[200])
 {
 //Draw the shape
 dimensions dim = messageBox(text,0);

 //Draw the button
 button(dim.x+(dim.width/2)-3,dim.y+dim.height-2,"  OK  ",1);

 //Get out only if 'Space Bar' or 'Enter' or 'Esc' is pressed.
 char ch=0;
 int flag=1;
 while(flag)
  {
  ch=getch();
  if(ch==27||ch==13||ch==32) flag=0;
  }

 //This will resotre the contents behind the alert
 puttext(dim.x,dim.y,dim.x+dim.width,dim.y+dim.height, dim.buffer);
 }

int confirm(char text[200],int type)
 {
 //Draw the shape
 dimensions dim = messageBox(text,1);

 char but1[15],but2[15];
 //The type of buttons
 if(type == 1)
  {
  strcpy(but1,"  Yes ");
  strcpy(but2,"  No  ");
  }
 else
  {
  strcpy(but1,"  OK  ");
  strcpy(but2,"Cancel");
  }

 //Draw the buttons
 int y=dim.y+dim.height-2;
 int quater = dim.width/4;
 button(dim.x+quater-3, y, but1,1);
 button(dim.x+dim.width-quater-5, y, but2,0);

 //Get out only if 'Space Bar' or 'Enter' or 'Esc' is pressed.
 char ch=0;
 int flag=1;
 int sel=1;
 while(flag)
  {
  ch=getch();
  if(ch==13||ch==32) flag=0; //Enter or Space
  if(ch==27) //Escape
   {
   sel=0;
   flag=0;
   }
  //Select another button
  else if(ch==9||ch==77||ch==75) //Tab, Right or Left arrow key.
   {
   if(sel)
    {
    button(dim.x+quater-3, y, but1,0);
    button(dim.x+dim.width-quater-6, y, but2,1);
    sel=0;
    }
   else
    {
    button(dim.x+quater-3, y, but1,1);
    button(dim.x+dim.width-quater-6, y, but2,0);
    sel=1;
    }
   }
  }
 //This will resotre the contents behind the alert
 puttext(dim.x,dim.y,dim.x+dim.width,dim.y+dim.height,dim.buffer);
 return sel;
 }

//Copied from BD V 2.00.A 
/***************************** IsColor *****************************/
//This funciton will return 1 if the argument is a colour
//Needed when colouring items by command line. Return the colour value.
int isColor(char arg[20],int limit)
 {
 int color = -1;

 if(!strcmpi(arg,"black")||!strcmp(arg,"0"))              { color = 0; }
 else if(!strcmpi(arg,"blue")||!strcmp(arg,"1"))          { color = 1; }
 else if(!strcmpi(arg,"green")||!strcmp(arg,"2"))         { color = 2; }
 else if(!strcmpi(arg,"cyan")||!strcmp(arg,"3"))          { color = 3; }
 else if(!strcmpi(arg,"red")||!strcmp(arg,"4"))           { color = 4; }
 else if(!strcmpi(arg,"magenta")||!strcmp(arg,"5"))       { color = 5; }
 else if(!strcmpi(arg,"brown")||!strcmp(arg,"6"))         { color = 6; }
 else if(!strcmpi(arg,"lightgray")||!strcmp(arg,"7"))     { color = 7; }
 else if(!strcmpi(arg,"darkgray")||!strcmp(arg,"8"))      { color = 8; }
 else if(!strcmpi(arg,"lightblue")||!strcmp(arg,"9"))     { color = 9; }
 else if(!strcmpi(arg,"lightgreen")||!strcmp(arg,"10"))   { color = 10; }
 else if(!strcmpi(arg,"lightcyan")||!strcmp(arg,"11"))    { color = 11; }
 else if(!strcmpi(arg,"lightred")||!strcmp(arg,"12"))     { color = 12; }
 else if(!strcmpi(arg,"lightmagenta")||!strcmp(arg,"13")) { color = 13; }
 else if(!strcmpi(arg,"yellow")||!strcmp(arg,"15"))       { color = 14; }
 else if(!strcmpi(arg,"white")||!strcmp(arg,"16"))        { color = 15; }

 if(color>limit) color=-1;
 return color;
 }

/***************************** Help Screen *****************************/
//Much of this is copied for BD 2.00.A
void help(char show[10])
 {
 //To show the help page by page and not as a scrolling page.
 int per_page=0;
 if(!strcmpi(show,"break")||!strcmpi(show,"page")||!strcmpi(show,"b"))
  { per_page=1; }

 cout<<"Message "<<version<<"     By      Binny's Softwares\n\n"
     <<"http://www.geocities.com/binnyva\nE-Mail : binnyva@rediffmail.com\n\n"
     <<"Usage : Message [OPTIONS] \"<Message Text>\"\n\n"
     <<"Shows a message box with the text specifed as the argument. This message box "
     <<"can be in the from of an alert - just the OK button or as a conformation "
     <<"box - two buttons will be shown - OK and Cancel(can be changed). Any one button can "
     <<"be chosen using the arrow keys and enter. If OK is selected, the errorlevel will be "
     <<"set to 1 and if Cancel is selected, the error level will be 0.\n"
     <<"The text colour and background colour of all elements can be set from the command line.\n"
     <<"All the command line options are discribed below.\n\n";

  cout<<"Example: message -bg blue -t BLACK -hs \"Hello World\"\n";
 if(per_page)
  {
  cout<<"\n\nPress any key for more...\n\n\n";
  getch();
  }

 cout<<"\nCommand Line Options\n--------------------\n"
     <<"--hide_shadow OR -hs - Disables the drop shadow effect.\n"
     <<"--yesno OR -yn       - The Button text will be 'Yes' and 'No'.\n"
     <<"--okcancel OR -oc    - The Button text will be 'OK' and 'Cancel'.\n"
     <<"--delimiter <#>      - Sets the delimiter at the ends of the button.\n"
     <<"    OR -d <#>            <#> can be any of the following values.\n"
     <<"                         0 -   Text  (No Delimiters)\n"
     <<"                         1 - < Text >\n"
     <<"                         2 - - Text -\n"
     <<"                         3 - [ Text ]\n"
     <<"                         4 - .: Text :.\n"
     <<"-? OR --help         - Shows help screen (this screen)\n"
     <<"-? break             - Shows help page by page.\n\n";
 cout<<"Example : message -yn --delimiter 4 \"Hello World\"\n";

 if(per_page)
  {
  cout<<"\n\nPress any key for more...\n\n\n";
  getch();
  }

 cout<<"\nColour Options\n--------------\n"
     <<"The all the colours can be set from the command line.\n"
     <<"The format is given below.\t\tNote : MB - Message Box\n"
     <<"Ŀ\n"
     <<"            Command Line                	         Function             \n"
     <<"Ĵ\n"
     <<"--border_color <colour> OR -bc <colour>  The colour of the border of the MB.\n"
     <<"--background <colour> OR -bg <colour>    The background colour MB.          \n"
     <<"--text_color <colour> OR -tc <colour>    The text colour in MB.             \n"
     <<"--button_text_color <colour> OR          The text colour of the selected    \n"
     <<"	    -btc <colour>	         	    button.                   \n"
     <<"--button_background <colour> OR          The background colour of the       \n"
     <<"	    -bbg <colour>                          selected button.          \n"
     <<"--disabled_text_color <colour> OR        The text colour of the button that \n"
     <<"           -dtc <colour>                          is NOT selected.          \n"
     <<"--disabled_background <colour> OR        The background colour of the	button\n"
     <<"           -dbg <colour>                          that is NOT selected.     \n"
     <<"--shadow_color <colour> OR               The colour of the Shadow.          \n"
     <<"           -sc <colour>                                                     \n"
     <<"\n";
 cout<<"<colour> can be any color specified in the below chart. You can use\n"
     <<"   the code instead of the colour name. Please be careful to give \n"
     <<"   only the first 8 colors in the chart as the background color.\n";

 if(per_page)
  {
  cout<<"Press any key for more...";
  getch();
  }

 cout<<"\n\nAvailable Colors\n---------------\n"
     <<"Ŀ\n"
     <<"Color Name   Code  Background \n"
     <<"Ĵ\n"
     <<"BLACK         0    Yes        \n"
     <<"BLUE          1    Yes        \n"
     <<"GREEN         2    Yes        \n"
     <<"CYAN          3    Yes        \n"
     <<"RED           4    Yes        \n"
     <<"MAGENTA       5    Yes        \n"
     <<"BROWN         6    Yes        \n"
     <<"LIGHTGRAY     7    Yes        \n"
     <<"DARKGRAY      8    No         \n"
     <<"LIGHTBLUE     9    No         \n"
     <<"LIGHTGREEN   10    No         \n"
     <<"LIGHTCYAN    11    No         \n"
     <<"LIGHTRED     12    No         \n"
     <<"LIGHTMAGENTA 13    No         \n"
     <<"YELLOW       14    No         \n"
     <<"WHITE        15    No         \n"
     <<"\n\n";

 exit(0);
 }

/************************************ Main *********************************************/
void main(int argc,char *argv[])
 {
// textbackground(0);
// clrscr();

 //Value of button determines the text of buttons. It will change
 //		accoding to command line
 //	0 - OK
 //     1 - Yes No
 //	2 - OK Cancel
 int button=0;
 char text[200]="";
 int selection=-1;
 int y=wherey();

 //Getting the Command Line Options (CLO)
 for(int i=1;i<argc;i++)
  {
  //If Command line argument is a CLO
   //Button type
   if(!strcmpi(argv[i],"--yesno")||!strcmpi(argv[i],"-yn")) button=1;
   else if(!strcmpi(argv[i],"--okcancel")||!strcmpi(argv[i],"-oc")) button=2;
   //Settings
   else if(!strcmpi(argv[i],"--hide_shadow")||!strcmpi(argv[i],"-hs")) hide_shadow=1;
   else if(!strcmpi(argv[i],"--delimiter")||!strcmpi(argv[i],"-d"))
    { if(isColor(argv[i+1],4) >= 0) delimiter = isColor(argv[++i],4); }
   //Colour Configuration
   else if(!strcmpi(argv[i],"--border_color")||!strcmpi(argv[i],"-bc"))
    { if(isColor(argv[i+1],15) >= 0) border_color = isColor(argv[++i],15); }
   else if(!strcmpi(argv[i],"--background")||!strcmpi(argv[i],"-bg"))
    { if(isColor(argv[i+1],7) >= 0) background = isColor(argv[++i],7); }
   else if(!strcmpi(argv[i],"--text_color")||!strcmpi(argv[i],"-tc"))
    { if(isColor(argv[i+1],15) >= 0) text_color = isColor(argv[++i],15); }
   else if(!strcmpi(argv[i],"--button_background")||!strcmpi(argv[i],"-bbg"))
    { if(isColor(argv[i+1],7) >= 0) button_background = isColor(argv[++i],7); }
   else if(!strcmpi(argv[i],"--button_text_color")||!strcmpi(argv[i],"-btc"))
    { if(isColor(argv[i+1],15) >= 0) button_text_color = isColor(argv[++i],15); }
   else if(!strcmpi(argv[i],"--disabled_background")||!strcmpi(argv[i],"-dbg"))
    { if(isColor(argv[i+1],7) >= 0) disabled_background = isColor(argv[++i],7); }
   else if(!strcmpi(argv[i],"--disabled_text_color")||!strcmpi(argv[i],"-dtc"))
    { if(isColor(argv[i+1],15) >= 0) disabled_text_color = isColor(argv[++i],15); }
   else if(!strcmpi(argv[i],"--shadow_color")||!strcmpi(argv[i],"-sc"))
    { if(isColor(argv[i+1],15) >= 0) shadow_color = isColor(argv[++i],15); }
   else if (!strcmpi(argv[i],"--help")||!strcmpi(argv[i],"-h")||!strcmpi(argv[i],"-?")||!strcmpi(argv[i],"/?"))
    { help(argv[i+1]); }
  //Command line argument is not a CLO
  else
   {
   strcat(text,argv[i]);
   strcat(text," "); //Insert space for in between all arguments
   }
  }

 //If no arguments
 if(argc<2) { help("break"); }

 if(button)
  {
  selection=confirm(text,button);
  }
 else
  {
  alert(text);
  }

 gotoxy(1,y);
 textcolor(7);textbackground(0);
 if(selection>=0) exit(selection);
// getch();
 }
/***********************************************************************
TO DO
-----
1. Add mouse support.
2. More Buttons.
3. User specifed buttons.
***********************************************************************/