/****************************************************************************
Program    : Select
Version    : 1.00.A
Programmer : Binny V Abraham
E-Mail     : binnyva@rediffmail.com
Website    : http://www.geocities.com/binnyva
C++ Special: http://www.geocities.com/binnyva/code/cpp/

Use
---
Displays a menu with items specifed in the command line. The choice
is set as the errorlevel.

Special
-------
This is a part of the Batch Toolkit by Binny's softwares. To find out more,
go to http://www.geocities.com/binnyva. Programs in Batch Toolkit -
Becho, Getline, Message, Select, Tnd. Made for use in Batch files.

License
-------
You can use this program, modify it, distribute it, make money from it or
any thing by it. But please give credit where credit is due. Mention my name
or my site in the credits.

Disclamer
---------
If any thing happens to your computer by using my program, it is NOT my porblem. 
It will be your own fault.

If you want more info, contact me at binnyva@rediffmail.com.
****************************************************************************/
#include <string.h>
#include <process.h>
#include <iostream.h>
#include <conio.h>

//Global Declarations
char version[]="1.00.A";

//Default Colour Settings
int sel_back_color=LIGHTGRAY; //Selected Back Colour
int sel_text_color=WHITE; //Selected Text Colour
int back_color=BLACK; //Default Back Colour
int text_color=WHITE; //Default Text Colour

//Other options
int fill=1; //This will make all menus equal in length
int show_help=1; //See showInfo() function for more details.
int show_numbers=0; //Will show Item index

//For pogram
int lengthest=1;

/***************************** IsColor *****************************/
//This funciton will return 1 if the argument is a colour
//Needed when colouring items by command line. Return the colour value.
//This is copied from the BD program
int isColor(char arg[20])
 {
 int color = -1;

 if(!strcmpi(arg,"black")||!strcmp(arg,"0"))              { color = 0; }
 else if(!strcmpi(arg,"blue")||!strcmp(arg,"1"))          { color = 1; }
 else if(!strcmpi(arg,"green")||!strcmp(arg,"2"))         { color = 2; }
 else if(!strcmpi(arg,"cyan")||!strcmp(arg,"3"))          { color = 3; }
 else if(!strcmpi(arg,"red")||!strcmp(arg,"4"))           { color = 4; }
 else if(!strcmpi(arg,"magenta")||!strcmp(arg,"5"))       { color = 5; }
 else if(!strcmpi(arg,"brown")||!strcmp(arg,"6"))         { color = 6; }
 else if(!strcmpi(arg,"lightgray")||!strcmp(arg,"7"))     { color = 7; }
 else if(!strcmpi(arg,"darkgray")||!strcmp(arg,"8"))      { color = 8; }
 else if(!strcmpi(arg,"lightblue")||!strcmp(arg,"9"))     { color = 9; }
 else if(!strcmpi(arg,"lightgreen")||!strcmp(arg,"10"))   { color = 10; }
 else if(!strcmpi(arg,"lightcyan")||!strcmp(arg,"11"))    { color = 11; }
 else if(!strcmpi(arg,"lightred")||!strcmp(arg,"12"))     { color = 12; }
 else if(!strcmpi(arg,"lightmagenta")||!strcmp(arg,"13")) { color = 13; }
 else if(!strcmpi(arg,"yellow")||!strcmp(arg,"15"))       { color = 14; }
 else if(!strcmpi(arg,"white")||!strcmp(arg,"16"))        { color = 15; }

 return color;
 }

/***************************** fillSting() *****************************/
//To append spaces at end of every item that is smaller than 'lengthest'
//	item. This will make the menu look better.
void fillString(char *str)
 {
 int length=strlen(str);
 if(length)
  {
  //To append spaces at end of every item that is smaller than 'lengthest'.
  for(int i=length;i<lengthest;i++)
   { str[i]=' '; }
  str[i]='\0';
  }
 }

//This will show the currently selected option. If sel is more than
//	25, sel - 25 is the final choice.
void showInfo(int x,int y,int sel,char item[25])
 {
 gotoxy(x,y);
 textcolor(7);textbackground(0);
 if(sel<25)
  {
  cout<<"Currently Selected : ";
  if(show_numbers) cout<<sel<<") ";
  cout<<item;
  }
 else if(sel==25)
  {
  cout<<"Selection Cancelled.                 ";
  }
 else
  {
  sel=sel-25;
  cout<<"Selected Item : ";
  if(show_numbers) cout<<"("<<sel<<") ";
  cout<<item<<"         ";
  }
 }

/********************BackMenu() for intractive menus***********************/
//The format is copied for 'Effects.h' but a lot of changes were made.
void text(int x,int y,int sel,char txt[25])
 {
 if(!sel) //Item is selected
  {
  textbackground(sel_back_color);
  textcolor(sel_text_color);
  }
 else
  {
  textbackground(back_color);
  textcolor(text_color);
  }
 gotoxy(x,y);
 cputs(txt);
 }
int BackMenu(int x,int y,int num,char a[25],char b[25],char c[25],char d[25],char e[25],char f[25],char g[25],char h[25])
 {
 char ch;
 int key=72,sel=1;

 //Get all items in an array
 char item[8][25];
 strcpy(item[0],a);
 strcpy(item[1],b);
 strcpy(item[2],c);
 strcpy(item[3],d);
 strcpy(item[4],e);
 strcpy(item[5],f);
 strcpy(item[6],g);
 strcpy(item[7],h);

 //Print the first menu with the first item sellected.
 textbackground(sel_back_color);textcolor(sel_text_color);
 gotoxy(x,y);cputs(a);
 textbackground(back_color);textcolor(text_color);
 //Then print the rest as default.
 for(int i=1;i<num;i++)
  {
  gotoxy(x,y+i);
  cputs(item[i]);
  }
 if(show_help) showInfo(x,num+y,1,item[0]);

 while (key!=13) //Until Enter Key is pressed
  {
  key=getch();

  //Otherwise pressing any invalid key will remove the selection.
  //Note : 49 is the ascii code of '1'
  if((key==72)||(key==80)||(key<49+num&&key>49)||(key==27))
   text(x,y+sel-1,1,item[sel-1]);

  switch(key)
   {
   case 72: //UP
    //Note that 'sel' starts at 1 and not 0.
    if(sel==1) text(x,y+num-1,0,item[num-1]);
    else text(x,y+sel-2,0,item[sel-2]);

    if(sel==1) sel=num;
    else sel--;

    break;
   case 80: //DOWN
    if(sel==num) text(x,y,0,item[0]);
    else text(x,y+sel,0,item[sel]);

    if(sel==num) sel=1;
    else sel++;

   break;
   //Number selections.
   case '1':
    text(x,y,0,item[0]);
    sel=1;
    goto end;
   case '2':
    text(x,y+1,0,item[1]);
    sel=2;
    goto end;
   case '3':
    if(num>=3)
     {
     text(x,y+2,0,item[2]);
     sel=3;
     goto end;
     }
    else break;
   case '4':
    if(num>=4)
     {
     text(x,y+3,0,item[3]);
     sel=4;
     goto end;
     }
    else break;
   case '5':
    if(num>=5)
     {
     text(x,y+4,0,item[4]);
     sel=5;
     goto end;
     }
    else break;
   case '6':
    if(num>=6)
     {
     text(x,y+5,0,item[5]);
     sel=6;
     goto end;
     }
    else break;
   case '7':
    if(num>=7)
     {
     text(x,y+6,0,item[6]);
     sel=7;
     goto end;
     }
    else break;
   case '8':
    if(num==8)
     {
     text(x,y+7,0,item[7]);
     sel=8;
     goto end;
     }
    else break;

   case 27:sel=0; goto end; //Escape Button.
   default:break;
   }

  if(show_help) showInfo(x,num+y,sel,item[sel-1]);
  }

 end:
 //Show the selected.
 if(show_help) showInfo(x,num+y,sel+25,item[sel-1]);
 return sel;
 }

/***************************** Help Screen *****************************/
//Much of this is copied for BD 2.00.A
void help(char show[10])
 {
 //To show the help page by page and not as a scrolling page.
 int per_page=0;
 if(!strcmpi(show,"break")||!strcmpi(show,"page")||!strcmpi(show,"b"))
  { per_page=1; }

 cout<<"Select "<<version<<"     By      Binny's Softwares\nhttp://www.geocities.com/binnyva\n"
     <<"E-Mail : binnyva@rediffmail.com\n\n"
     <<"Usage : Select [OPTIONS] <Menu Item> <Menu Item> <Menu Item> ...\n\n"
     <<"Select will show a interactive arrow-keys driven menu from which "
     <<"the user can make a selection. The number of the selection will be "
     <<"set as the errorlevel. The is useful in batch scripts. \n"
     <<"The text colour and background colour can be set from the command line.\n\n";
 cout<<"OPTIONS\n-------\n"
     <<"--hide_info OR -hi    - Hides the \"Currently Selected\" text.\n"
     <<"--show_numbers OR -sn - Shows numbers for each element in the menu.\n"
     <<"--no_fill OR -nf      - This will cause the background to be the\n"
     <<"                              same width as the text.\n"
     <<"-? OR --help          -  Show help screen (this screen)\n"
     <<"-? break              -  Shows help page by page.\n\n";

 if(per_page)
  {
  cout<<"Press any key for more...\n\n\n";
  getch();
  }

 cout<<"Colour Options\n--------------\n"
     <<"The text colour and background colour can be set from the command line.\n"
     <<"The format is given below.\n"
     <<"Ŀ\n"
     <<"            Command Line             		    Function               \n"
     <<"Ĵ\n"
     <<"--back <colour> OR -b <colour>        Sets the default background colour.\n"
     <<"--text <colour> OR -t <colour>        Sets the default text colour.      \n"
     <<"--select_back <colour> OR -s <colour> Sets the background colour for     \n"
     <<"				      	    selected items.                \n"
     <<"--select_text <colour> OR -t <colour> Sets the colour of the selected    \n"
     <<"				      	    item.                          \n"
     <<"\n\n";
 cout<<"<colour> can be any color specified in the below chart. You can use\n"
     <<"   the code instead of the colour name. Please be careful to give \n"
     <<"   only the first 8 colors in the chart as the background color.\n\n";
 cout<<"Example: select \"Item 1\" \"Item 2\" \"Item 3\" -b LIGHTGRAY -t BLACK\n"
     <<"               -sb LIGHTGREEN -st RED\n\n";

 if(per_page)
  {
  cout<<"Press any key for more...";
  getch();
  }

 cout<<"\n\nAvailable Colors\n---------------\n"
     <<"Ŀ\n"
     <<"Color Name   Code  Background \n"
     <<"Ĵ\n"
     <<"BLACK         0    Yes        \n"
     <<"BLUE          1    Yes        \n"
     <<"GREEN         2    Yes        \n"
     <<"CYAN          3    Yes        \n"
     <<"RED           4    Yes        \n"
     <<"MAGENTA       5    Yes        \n"
     <<"BROWN         6    Yes        \n"
     <<"LIGHTGRAY     7    Yes        \n"
     <<"DARKGRAY      8    No         \n"
     <<"LIGHTBLUE     9    No         \n"
     <<"LIGHTGREEN   10    No         \n"
     <<"LIGHTCYAN    11    No         \n"
     <<"LIGHTRED     12    No         \n"
     <<"LIGHTMAGENTA 13    No         \n"
     <<"YELLOW       14    No         \n"
     <<"WHITE        15    No         \n"
     <<"\n\n";

 exit(0);
 }

/***************************** Function Main *****************************/
void main(int argc,char *argv[])
 {
 //Initialize all the strings
 char a[25] = "";
 char b[25] = "";
 char c[25] = "";
 char d[25] = "";
 char e[25] = "";
 char f[25] = "";
 char g[25] = "";
 char h[25] = "";

 int no=0,y=1;
 int result=0;
 int debug=0;
 int problem=0;

 if(debug==2) clrscr();

 for(int i=1;i<argc;i++)
  {
  if(!strcmpi(argv[i],"--back")||!strcmpi(argv[i],"-b"))
   { if(isColor(argv[i+1]) >= 0) { back_color = isColor(argv[i+1]); i++; } }
  else if(!strcmpi(argv[i],"--text")||!strcmpi(argv[i],"-t"))
   { if(isColor(argv[i+1]) >= 0) { text_color = isColor(argv[i+1]); i++; } }
  else if(!strcmpi(argv[i],"--select_back")||!strcmpi(argv[i],"-sb"))
   { if(isColor(argv[i+1]) >= 0) { sel_back_color = isColor(argv[i+1]); i++; } }
  else if(!strcmpi(argv[i],"--select_text")||!strcmpi(argv[i],"-st"))
   { if(isColor(argv[i+1]) >= 0) { sel_text_color = isColor(argv[i+1]); i++; } }
  else if(!strcmpi(argv[i],"--no_fill")||!strcmpi(argv[i],"-nf")) { fill=0; }
  else if(!strcmpi(argv[i],"--show_numbers")||!strcmpi(argv[i],"-sn")) { show_numbers=1; }
  else if(!strcmpi(argv[i],"--hide_info")||!strcmpi(argv[i],"-hi")) { show_help=0; }
  else if(!strcmpi(argv[i],"--help")||!strcmpi(argv[i],"-?")||!strcmpi(argv[i],"-h")||!strcmpi(argv[i],"/?"))
   { help(argv[i+1]); }
  else if(!strcmpi(argv[i],"/debug")) { debug++; }
  else
   {
   //Get the items from the command line
   switch (no)
    {
    case 0:strcpy(a,argv[i]);break;
    case 1:strcpy(b,argv[i]);break;
    case 2:strcpy(c,argv[i]);break;
    case 3:strcpy(d,argv[i]);break;
    case 4:strcpy(e,argv[i]);break;
    case 5:strcpy(f,argv[i]);break;
    case 6:strcpy(g,argv[i]);break;
    case 7:strcpy(h,argv[i]);break;
    default:cout<<"Only eight items are allowed in a menu.\n";problem++;
    }
   no++;
   //Find the element of greatest length. Needed for 'fill'.
   if(strlen(argv[i])>lengthest) lengthest=strlen(argv[i]);
   }
  }

 //If no arguments are given
 if(argc<2)
  {
  help("break");
  }
 else
  {
  if(debug==3)
   {
   cout<<"All Items - \n";
   cout<<a<<"\n"<<b<<"\n"<<c<<"\n"<<d<<"\n"<<e<<"\n"
       <<f<<"\n"<<g<<"\n"<<h<<"\n";
   }

  //If the fill option is set
  if(fill)
   {
   fillString(&a[0]);
   fillString(&b[0]);
   fillString(&c[0]);
   fillString(&d[0]);
   fillString(&e[0]);
   fillString(&f[0]);
   fillString(&g[0]);
   fillString(&h[0]);
   }

  //If no errors have occured
  if(!problem)
   {
   //Get Position
   y = wherey();

   //Making space - If the prompt is at the bottom of the screen.
   if(y>24-no)
    {
    gotoxy(1,24-no);
    for(i=y-no;i<=30;i++) cout<<"\n";
    y=24-no;
    }

   //Display the numbers
   if(show_numbers)
    for(int i=1;i<=no;i++)
     {
     gotoxy(1,y+i-1);
     cout<<i;
     }

   //Call the menu
   result = BackMenu(3,y,no,a,b,c,d,e,f,g,h);
   }
  }

 //So that whatever comes next comes out of the menu.
 gotoxy(2,y+no);cout<<"\n";

 if(debug==2) getch();
 else exit(result);
 }
/***************************************************************************
TO DO
-----
Make no of menu items infinite.
Horizondel menu.

****************************************************************************/